//--------------------------------------------------------------------
//
//    board.h     APB-2   n[hEFA`
//
//--------------------------------------------------------------------

#ifndef _BOARD_H_
#define _BOARD_H_

typedef signed char     int8;
typedef signed short    int16;
typedef signed long     int32;
typedef unsigned char   uint8;
typedef unsigned short  uint16;
typedef unsigned long   uint32;
typedef signed char     bool;

#include "hcc_types.h"
#include "derivative.h"
#include "target.h"
#include "util.h"


#define TRUE     (1)
#define FALSE    (0)
#define ERR      (-1)
#define ENABLE   (1)
#define DISABLE  (0)

#define LED1_ON           (PTAD=0x80)       // ̃|[g̓I[vhCƂĎgߒl𒼐ړ
#define LED1_OFF          (PTAD=0)

#define SPI_MOSI_L        (PTADD_PTADD2=1)  // L=o̓|[g
#define SPI_MOSI_H        (PTADD_PTADD2=0)  // H=̓|[g

#define SPI_CLK_L         (PTADD_PTADD3=1)  // L=o̓|[g
#define SPI_CLK_H         (PTADD_PTADD3=0)  // H=̓|[g

#define SPI_MISO          (PTAD_PTAD1)

#define DF_CS_L           (PTADD_PTADD4=1)  // L=o̓|[g
#define DF_CS_H           (PTADD_PTADD4=0)  // H=̓|[g

#define FPGA_CS_L         (PTBDD_PTBDD0=1)  // L=o̓|[g
#define FPGA_CS_H         (PTBDD_PTBDD0=0)  // H=̓|[g

#define FPGA_CCLK_L       (PTADD_PTADD3=1)  // L=o̓|[g
#define FPGA_CCLK_H       (PTADD_PTADD3=0)  // H=̓|[g

#define FPGA_D0_L         (PTADD_PTADD1=1)  // L=o̓|[g
#define FPGA_D0_H         (PTADD_PTADD1=0)  // H=̓|[g

#define FPGA_PROGB_L      (PTADD_PTADD5=1)  // L=o̓|[g
#define FPGA_PROGB_H      (PTADD_PTADD5=0)  // H=̓|[g

#define FPGA_INITB        (PTBD_PTBD0)
#define FPGA_DONE         (PTAD_PTAD0)
#define FPGA_CSOB         (PTAD_PTAD4)

#define IS_FPGA_CONFIG    ( FPGA_DONE != 0 )

#define NOP               asm ( nop; )
#define MIN(a,b)          ((a) < (b) ? (a) : (b))
#define MAX(a,b)          ((a) > (b) ? (a) : (b))

#endif
