//--------------------------------------------------------------------
//
//    cmd.c     PC  USB oRŃR}h󂯎ߎs
//
//--------------------------------------------------------------------
//  
//  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
//  ľړIɂ́ACAȂǎRɎgpł܂B
//  \ۂ͒쌠\Ȃ悤ɂĂB
//  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
//  ƓIp͂߂B
//

#include "board.h"
#include "usb_cdc.h"
#include "spi.h"
#include "dataflash.h"
#include "fpga.h"
#include "cmd.h"


#define N_CMDS    6
static command_t cmds[N_CMDS] = {
//  { '?', cmd_help   },
  { 'd', cmd_dataflash  },              // DataFlash R}h
  { 'r', cmd_fpga_r },                  // fpga ǂݏoR}h
  { 'w', cmd_fpga_wh },                 // fpga 16i  R}h
  { 'c', cmd_fpga_config },             // fpga RtBOR}h
  { 0x01,cmd_fpga_write  },             // oCi[
  { 0x02,cmd_fpga_read  }               // oCi[ǂݏo
};


//-----------------------------------------------------------------------
//
//-----------------------------------------------------------------------
void cmd_help( void ) {
//  int x;
//  
//  putch('\r');
//  for(x=0; x < N_CMDS; x++) {
//    putch('\t');
//    putch( cmds[x].cmd ) ;
//    putch('\r');
//  }
//  putstr( "\r\t?\t\t\t:help message\r" );
  putstr( "\rversion 20110707\r\r" );
//  putstr( "\tm adr size\r" );
  putstr( "\td\t\t\t:dataflash id\r" );
  putstr( "\tdr page\t\t\t:dataflash read\r" );
  putstr( "\tdp bin_data\t\t:dataflash program\r" );
  putstr( "\tr adr\t\t\t:fpga read\r" );
//  putstr( "\tw adr bin_data\t\t:fpga write binary data\r" );
  putstr( "\tw adr hex_data\t\t:fpga write hex data\r" );
  putstr( "\tc\t\t\t:fpga cofig\r" );
//  putstr( "\tt\r" );
}


//-----------------------------------------------------------------------
//
//-----------------------------------------------------------------------
//void cmd_led( void ) {
//  static uint8 led=1;
//  putch('\r');
////  LED1_TGL;
//  if( led ) {
//    LED1_OFF;
//    led = 0;
//  }else{
//    LED1_ON;
//    led = 1;
//  }
//}


//-----------------------------------------------------------------------
//
//-----------------------------------------------------------------------
//void cmd_memory( void ) {
//  int adr, length;
//  int i;
//  
//  adr = gethex_echo( 20000 );
//  length = gethex_echo( 20000 );
//  if( length==0 ) length=16;
//  for( i=0; i<length; i++ ) {
//    if( (i & 0x0F) == 0 ) {
//      putch('\r');
//      print_hex_int( (int)adr );
//    }
//    putch( ' ' );
//    print_hex_byte( *((char *)adr) );
//    adr++;
//  }
//  putch('\r');
//}


//-----------------------------------------------------------------------
//  DataFlash R}h      dw:   dr page:ǂݏo   d:IDǂݏo
//-----------------------------------------------------------------------
void cmd_dataflash( void ) {
  int16 ch;
  char i;
  
  ch = getch_echo( 30000 );             // timeout=30s
  if( ch == 'p' ) {                     // (AhX 0000 )
    putstr( "\rPlease send data to program DataFlash.\r" );
    df_UnProtectAll();                  // veNg
    df_ChipErase();                     // `bvS
    print_hex_int( df_write_usb() );    // USB f[^ǂ݃tbVɏ
    df_ProtectAll();                    // veNg
    putstr( " pages written" );
  }else
  if( ch == 'r' ) {                     // ǂݏo(256oCg)
    uint16 page = gethex_echo( 30000 ); // ǂݏoy[Wԍ
    uint16 n=0;
    DF_CS_L;                            // L( open drain )
    spi_SendByte( 0x03 );                // Read Array
    df_SendAdrs( ((uint32)page)<<8 );
    while( n != 256 ) {
      if( (n & 0x0F)==0 ) {
        putch('\r');
        print_hex_int( (int)page );
        print_hex_byte( (uint8)n );
      }
      putch( ' ' );
      print_hex_byte( spi_RcvByte() );
      n++;
    }
    DF_CS_H;                            // H( open drain )
  }else{                                // IDǂݏo
    DF_CS_L;                            // L( open drain )
    spi_SendByte( 0x9F );                // Read Manufacturer and Device ID
    for( i=3; i; i-- ) {
      putch( ' ' );
      print_hex_byte( spi_RcvByte() );
    }
    DF_CS_H;                            // H( open drain )
  }
//  putch('\r');
}


////-----------------------------------------------------------------------
////  fpga R}h       fh adrs d..:16i    fw adrs:    fr adrs:ǂݏo   fc:RtBO
////-----------------------------------------------------------------------
//void cmd_fpga( void ) {
//  int16 ch;
////  char i;
//  
//  ch = getch_echo( 0 );                 // 1  timeoutȂ 
//  if( ch == 'h' ) {                     // 16i
//    uint16 adrs = gethex_echo( 20000 ); // ݃AhX
//    putch('\r');
//    print_hex_int( fpga_write_usb_hex( adrs ) );  // USB 16if[^ǂ FPGA ɏ
//    putstr( " bytes" );
//  }else
//  if( ch == 'w' ) {                     // 
//    uint16 adrs = gethex_echo( 20000 ); // ݃AhX
//    putstr( "\rWaiting for data.\r" );
//    print_hex_int( fpga_write_usb( adrs ) );  // USB f[^ǂ FPGA ɏ
//    putstr( " bytes" );
//  }else
//  if( ch == 'r' ) {                     // ǂݏo(16oCg)
//    uint16 adrs = gethex_echo( 20000 ); // ǂݏoAhX
//    uint16 n=0;
//    FPGA_CS_L;                          // L( open drain )
//    spi_SendByte( 0x03 );               // Read Array command
//    fpga_SendAdrs( adrs );
//    while( n != 16 ) {
//      if( (n & 0x0F)==0 ) {
//        putch('\r');
//        print_hex_int( adrs );
//      }
//      putch( ' ' );
//      print_hex_byte( spi_RcvByte() );
//      n++;
//    }
//    FPGA_CS_H;                          // H( open drain )
//  }else
//  if( ch == 'c' ) {                     // RtBO
//    if( fpga_config() ) putstr( "\rERROR" );
//  }
//  putch('\r');
//}


//-----------------------------------------------------------------------
//  fpga ǂݏoR}h       r adrs
//-----------------------------------------------------------------------
void cmd_fpga_r( void ) {
  uint16 adrs = gethex_echo( 30000 ); // ǂݏoAhX
  uint16 n=0;
  
  FPGA_CS_L;                          // L( open drain )  FPGA ANZXJn
  spi_SendByte( 0x03 );               // Read Array command
  fpga_SendAdrs( adrs );
  while( n != 16 ) {
    if( (n & 0x0F)==0 ) {
      putch('\r');
      print_hex_int( adrs );
    }
    putch( ' ' );
    print_hex_byte( spi_RcvByte() );
    n++;
  }
  FPGA_CS_H;                          // H( open drain )  FPGA ANZXI
}


//-----------------------------------------------------------------------
//  fpga 16i  R}h       w adrs hexdata
//-----------------------------------------------------------------------
void cmd_fpga_wh( void ) {
  uint16 adrs = gethex_echo( 30000 ); // ݃AhX
  putch('\r');
  print_hex_int( fpga_write_usb_hex( adrs ) );  // USB 16if[^͂ FPGA ɏ
  putstr( " bytes written" );
}


//-----------------------------------------------------------------------
//  fpga oCi[  R}h       0x01 adrs(2) size(2) bindata
//-----------------------------------------------------------------------
void cmd_fpga_write( void ) {
  int16 ch, buf[4];
  uint16 adrs, size;
  uint8 i, err=0;
  
  for( i=0; i<4; i++ ) {                // adress  size
    ch = getch(100);
    if( ch < 0 ) { putch('T'); return; }  // ^CAEg
    buf[i] = ch;
  }
  adrs = (buf[0]<<8) + buf[1]; // ݃AhX
  size = (buf[2]<<8) + buf[3]; // TCY
  
  if( size != fpga_write_usb( adrs ) ) {  // USB f[^ǂ FPGA ɏ
    putch('S');                         // TCYvȂ
  }
}


//-----------------------------------------------------------------------
//  fpga oCi[ǂݏo  R}h       0x02 adrs(2) size(2)
//-----------------------------------------------------------------------
void cmd_fpga_read( void ) {
  int16 ch, buf[4];
  uint16 adrs, size;
  uint8 i, err=0;
  
  for( i=0; i<4; i++ ) {                // adress  size
    ch = getch(100);
    if( ch < 0 ) { putch('T'); return; }  // ^CAEg
    buf[i] = ch;
  }
  adrs = (buf[0]<<8) + buf[1]; // ݃AhX
  size = (buf[2]<<8) + buf[3]; // TCY
  
  FPGA_CS_L;                          // L( open drain )  FPGA ANZXJn
  spi_SendByte( 0x03 );               // Read Array command
  fpga_SendAdrs( adrs );
  while( size-- ) {
    putch( spi_RcvByte() );  // ^CAEgȂ̂ PC f[^󂯎ȂƂŎ~܂Ă܂댯III
  }
  FPGA_CS_H;                          // H( open drain )  FPGA ANZXI
}


//-----------------------------------------------------------------------
//  fpga RtBOR}h       slave serial ̂Ƃ̓RtBOf[^(bit t@Cj󂯎
//-----------------------------------------------------------------------
void cmd_fpga_config( void ) {
  if( fpga_config() ) putstr( "\rERROR" );
}


//-----------------------------------------------------------------------
//
//-----------------------------------------------------------------------
//void cmd_test( void ) {
//  FPGA_CCLK_L;                        // 5clk
//  FPGA_CCLK_H;                        // 5clk
//  FPGA_CCLK_L;                        // 5clk
//  FPGA_CCLK_H;                        // 5clk
//  FPGA_CCLK_L;                        // 5clk
//  FPGA_CCLK_H;                        // 5clk
//}


//-----------------------------------------------------------------------
//    LED1 gO
//-----------------------------------------------------------------------
void led1_toggle( void ) {
  static uint8 led=1;
  if( led ) {
    LED1_OFF;
    led = 0;
  }else{
    LED1_ON;
    led = 1;
  }
}


//-----------------------------------------------------------------------
//
//-----------------------------------------------------------------------
void cmd_loop( void ) {
  char ch, n;
  ch = (char)getch_echo( 0 );         // ^CAEgȂ
  led1_toggle();
  for(n = 0; n < N_CMDS; n++) {
    if ( ch == cmds[n].cmd ) {
      (*cmds[n].func)();
      break;
    }
  }
  if( n == N_CMDS ) {
//    putstr("\r???");
    cmd_help();
  }
  putstr("\r\r>\000");
}

