//
//
//        dataflash.c     DataFlash ̓ǂݏ      by Ojisankoubou
//
//
//  
//  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
//  ľړIɂ́ACAȂǎRɎgpł܂B
//  \ۂ͒쌠\Ȃ悤ɂĂB
//  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
//  ƓIp͂߂B
//

#include "board.h"
#include "spi.h"
#include "dataflash.h"


////
//// PoCgM
////
//void spi_SendByte( char data ) {
//  uint8 i;
//  for( i=8; i; i-- ) {
//    SPI_CLK_L;
////    SPI_MOSI_L;
//    if( data & 0x80 ) SPI_MOSI_H;
//    else              SPI_MOSI_L;
//    data = data<<1;
//    SPI_CLK_H;
//  }
//  SPI_MOSI_H;
//}
//
//
////
//// PoCgM
////
//char spi_RcvByte( void ) {
//  uint8 i, data=0;
//  for( i=8; i; i-- ) {
//    SPI_CLK_L;
//    data = data<<1;
//    if( SPI_MISO ) data++;
//    SPI_CLK_H;
//  }
//  return data;
//}


//
//  DafaFlash  n oCgǂ buf ɓ
//
void df_read( int32 adrs, uint8 *buf, int16 n ) {
  int32 j;
  
  DF_CS_L;                         // L( open drain )
  spi_SendByte( 0x03 );                 // Read Array
  df_SendAdrs( adrs );
  j=0;
  while( n-- ) buf[j++] = spi_RcvByte();
  DF_CS_H;                          // H( open drain )
}


//
//  DafaFlash  buf  n oCg     ɃveNgĂ
//
void df_write( int32 adrs, uint8 *buf, int16 n ) {
  int16 j, k;
  int32 a;
  
  j=0;
  while( n > 0 ) {
    df_waitbusy();
    df_writeenable();
    a = adrs + j;
    k = MIN( (256-(a&0x000000FF)), n );
    n -= k;
    DF_CS_L;                       // L( open drain )
    spi_SendByte( 0x02 );               // Byte/Page Program
    df_SendAdrs( a );
    while( k-- ) spi_SendByte( buf[j++] );
    DF_CS_H;                        // H( open drain )
  }
}


//
//  DafaFlash  USB ̃f[^  ݂y[WԂ     ɃveNgĂ
//
uint16 df_write_usb( void ) {
  int16 ch, n, page=0;
  int32 adr=0;
  
  ch = getch( 30000 );                  // ŏ̃f[^Ă܂ł timeout=30s
  for(;;) {
    if( ch < 0 ) break;                 // if timeout
    df_waitbusy();
    df_writeenable();
    DF_CS_L;                            // L( open drain )
    spi_SendByte( 0x02 );               // Byte/Page Program
    df_SendAdrs( adr );
    adr += 256;
    page++;
    n = 256;
    while( n-- ) {
      if( ch < 0 ) break;               // if timeout
      spi_SendByte( (char)ch  );
      ch = getch( 100 );                // 2oCgڈȍ~ timeout=100ms ƒZ
    }
    DF_CS_H;                            // H( open drain )
    if( (page & 0x000F) == 0 ) putch( '.' );  // every 4kB
  }
  putch( '\r' );
  return page;
}


//
// ubNi4kBj     ɃveNgĂ
//
void df_BlockErase( int32 adrs ) {
  df_waitbusy();
  df_writeenable();
  DF_CS_L;                         // L( open drain )
  spi_SendByte( 0x20 );                 // Block Erase 4KB
  df_SendAdrs( adrs );
  DF_CS_H;                          // H( open drain )
}


//
// `bvS     ɃveNgĂ
//
void df_ChipErase( void ) {
  df_waitbusy();
  df_writeenable();
  DF_CS_L;                         // L( open drain )
  spi_SendByte( 0x60 );                 // Chip Erase
  DF_CS_H;                          // H( open drain )
}


//
//  DafaFlash  Busy ̊ԑ҂
//
void df_waitbusy( void ) {
  DF_CS_L;                         // L( open drain )
  spi_SendByte( 0x05 );                 // Read Status Register
  while( spi_RcvByte() & 0x01 );        // wait until device becomes ready
  DF_CS_H;                          // H( open drain )
}


//
//  DafaFlash  WE rbg𗧂Ă( ݉\ )
//
void df_writeenable( void ) {
  DF_CS_L;                         // L( open drain )
  spi_SendByte( 0x06 );                 // WE
  DF_CS_H;                          // H( open drain )
}


//
// ׂẴZN^[̃veNgrbg
//
void df_UnProtectAll( void ) {
  df_writeenable();
  DF_CS_L;                         // L( open drain )
  spi_SendByte( 0x01 );                 // write status register
  spi_SendByte( 0x00 );                 // unprotect all
  DF_CS_H;                          // H( open drain )
}


//
// ׂẴZN^[̃veNgrbgĂ
//
void df_ProtectAll( void ) {
  df_writeenable();
  DF_CS_L;                         // L( open drain )
  spi_SendByte( 0x01 );                 // write status register
  spi_SendByte( 0x3C );                 // protect all
  DF_CS_H;                          // H( open drain )
}


//
// AhXi3 bytesj𑗂    big-endien( ŏʃoCgŏ )
//
void df_SendAdrs( int32 adrs ) {
  uint8 i;
//  for ( i=0; i<3; i++ ) {               // address 3bytes MSB first
//    spi_SendByte( (char)((adrs&0x00FF0000)>>16) );
//    adrs = adrs<<8;
//  }
//  for ( i=3; i; i-- ) {               // address 3bytes MSB first
//    spi_SendByte( (char)((adrs&0x00FF0000)>>16) );
//    adrs = adrs<<8;
//  }
  spi_SendByte( (char)(adrs>>16) );
  spi_SendByte( (char)(adrs>>8) );
  spi_SendByte( (char)adrs );
}



