//--------------------------------------------------------------------
//
//                    fpga.c         eof`
//
//--------------------------------------------------------------------
//  
//  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
//  ľړIɂ́ACAȂǎRɎgpł܂B
//  \ۂ͒쌠\Ȃ悤ɂĂB
//  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
//  ƓIp͂߂B
//

#include "board.h"
#include "usb_cdc.h"
#include "spi.h"
#include "fpga.h"


//
//  FPGA  USB  16 if[^@݂͉sŏI@݂oCgԂ
//
uint16 fpga_write_usb_hex( uint16 adrs ) {
  int16  ch;
  uint8  hex=0;
  uint16 n=0;
  
  FPGA_CS_L;                            // L( open drain )
  spi_SendByte( 0x02 );                 // Page Program
  fpga_SendAdrs( adrs );
  for(;;) {
    ch = getch_echo(0);                 // 
    if( ishex( (char)ch ) ) {
      hex = (hex<<4) + ch2hex( (char)ch );
      continue;
    }
    spi_SendByte( hex  );
    hex = 0;
    n++;
    if( (char)ch == '\r' ) break;       // sŏI
  }
  FPGA_CS_H;                            // H( open drain )
  return n;
}


//
//  FPGA  USB ̃f[^@݂oCgԂ
//
uint16 fpga_write_usb( uint16 adrs ) {
  int16 ch;
  uint16 n=0;
  uint16 timeout=30000;
  
  FPGA_CS_L;                            // L( open drain )
  spi_SendByte( 0x02 );                 // Page Program
  fpga_SendAdrs( adrs );
  for(;;) {
    ch = getch( timeout );              // 
    if( ch < 0 ) break;                 // if timeout
    spi_SendByte( (char)ch  );
    timeout = 500;                      // timeout=500ms
    n++;
  }
  FPGA_CS_H;                            // H( open drain )
  return n;
}


//--------------------------------------------------------------------
// FPGA  CONFIG     error Ԃ@0:No error
//--------------------------------------------------------------------
int8 fpga_config( void ) {
  uint8 i;
  uint16 timeout;
  uint16 size=0;
  
  putstr( "\rConfig: " );
  
  FPGA_PROGB_L;
  delay_usec( 1 );                      // 500ns min 
  FPGA_PROGB_H;
  
  timeout = 10000;                      // =10ms  0.5-2ms for XC3SxxA
  while( FPGA_INITB == 0 ) {            // wait till INIT_B becomes High
    delay_usec( 1 );
    if( (timeout--) == 0 ) {            // 
      putch( 'T' );
      return -1;
    }
  }
  
  delay_usec( 100 );                    // Master SPI ̂Ƃ FPGA  CSO_B  'L' ɂ܂ł̑҂=100us
  if( FPGA_CSOB == 0 ) {                // Master SPI mode ŃRtBOJnĂ邩
    putstr( "Master SPI\r" );
    return 0;
  }
  putstr( "Slave serial\rPlease send FPGA config data(.bit).\r" );
  
  timeout = 30000;                      // 30s
  for(;;) {
    uint8 c;
    int16 d = getch( timeout );
    timeout = 100;                      // 100ms
    if( d < 0 ) break;                  // timeout?
    c = (uint8)d;
    for( i=8; i; i-- ) {
      FPGA_CCLK_L;                      // 5clk
//      FPGA_D0_L;
      if( c & 0x80 ) FPGA_D0_H;
      else           FPGA_D0_L;
      c = c<<1;
      FPGA_CCLK_H;                      // 5clk
    }
    FPGA_D0_H;
    size++;
    if( (((uint16)size) & 0x0FFF) == 0 ) putch( '.' );  // every 4kB   XC3S50A:53kB  200A:146kB
  }
  putch( '+' );
  
  timeout = 30000;
  while( FPGA_DONE == 0 ) {             // CCLK till DONE becomes High
    FPGA_CCLK_L;                        // 5clk
    FPGA_CCLK_H;                        // 5clk
    if( FPGA_INITB == 0 ) {             // CRC error ?
      putch( 'E' );
      return -3;
    }
    if( (timeout--)==0 ) {
      putch( 'T' );
      return -4;
    }
  }
  putch( '*' );
  
  for( i=4; i; i-- ) {                  // additional CCLK for startup
    FPGA_CCLK_L;                        // 5clk
    FPGA_CCLK_H;                        // 5clk
  }
  
  return 0;
}


//
// AhXi2 bytesj𑗂
//
void fpga_SendAdrs( uint16 adrs ) {
  spi_SendByte( (char)(adrs>>8) );
  spi_SendByte( (char)(adrs) );
}


